----------------------------------------------------------------------
-- Created by SmartDesign Mon Oct  4 16:54:30 2021
-- Version: v2021.2 2021.2.0.11
----------------------------------------------------------------------

----------------------------------------------------------------------
-- Libraries
----------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.genram_pkg.all;
use work.memory_loader_pkg.all;

entity sb_envm_sb is
  -- Port list
  port(
        -- Inputs
        CLK0                                : in  std_logic;
        DEVRST_N                            : in  std_logic;
        FAB_RESET_N                         : in  std_logic;
        HPMS_FIC_0_USER_MASTER_HADDR_M0     : in  std_logic_vector(31 downto 0);
        HPMS_FIC_0_USER_MASTER_HBURST_M0    : in  std_logic_vector(2 downto 0);
        HPMS_FIC_0_USER_MASTER_HMASTLOCK_M0 : in  std_logic;
        HPMS_FIC_0_USER_MASTER_HPROT_M0     : in  std_logic_vector(3 downto 0);
        HPMS_FIC_0_USER_MASTER_HSIZE_M0     : in  std_logic_vector(2 downto 0);
        HPMS_FIC_0_USER_MASTER_HTRANS_M0    : in  std_logic_vector(1 downto 0);
        HPMS_FIC_0_USER_MASTER_HWDATA_M0    : in  std_logic_vector(31 downto 0);
        HPMS_FIC_0_USER_MASTER_HWRITE_M0    : in  std_logic;
        -- Outputs
        COMM_BLK_INT                        : out std_logic;
        FIC_0_CLK                           : out std_logic;
        FIC_0_LOCK                          : out std_logic;
        HPMS_FIC_0_USER_MASTER_HRDATA_M0    : out std_logic_vector(31 downto 0);
        HPMS_FIC_0_USER_MASTER_HREADY_M0    : out std_logic;
        HPMS_FIC_0_USER_MASTER_HRESP_M0     : out std_logic_vector(1 downto 0);
        HPMS_INT_M2F                        : out std_logic_vector(15 downto 0);
        HPMS_READY                          : out std_logic;
        INIT_DONE                           : out std_logic;
        POWER_ON_RESET_N                    : out std_logic
    );
end sb_envm_sb;

architecture RTL of sb_envm_sb is
  signal PRDATA  : std_logic_vector(31 downto 0);
  signal PREADY  : std_logic;
  signal PSLVERR : std_logic;
begin
  power_on_reset_n <= devrst_n;

  hpms_ready <= '1';
  init_done <= '1';
  fic_0_lock <= '1';

  fic_0_clk <= clk0 after 4 ns;
  
  HPMS_FIC_0_USER_MASTER_HRDATA_M0  <= prdata;
  HPMS_FIC_0_USER_MASTER_HREADY_M0  <= pready;

  process (clk0)
    constant IRAM_WIDTH : natural := 14;
    constant IRAM_WSIZE : natural := 2 ** (IRAM_WIDTH - 2);
    constant mem : t_ram32_type(0 to IRAM_WSIZE - 1) :=
      f_load_mem32_from_file ("../../../sw/fip_urv/fip_urv.ram", IRAM_WSIZE, True);
    variable state : natural;
    variable addr : std_logic_vector(31 downto 0);
  begin
    if rising_edge(clk0) then
      pready <= '0';
      pslverr <= '0';
      if devrst_n = '0' then
        state := 0;
      else
        case state is
          when 0 =>
            if hpms_fic_0_user_master_htrans_m0 = "10" then
              assert hpms_fic_0_user_master_hwrite_m0 = '0';
              addr := hpms_fic_0_user_master_haddr_m0;
              pready <= '1';
              state := 1;
            end if;
          when 1 =>
            if addr = x"6008_0120" then
              state := 2;
            else
              PRDATA <= mem (to_integer(unsigned(hpms_fic_0_user_master_haddr_m0(IRAM_WIDTH downto 2))));
              pready <= '1';
              state := 0;
            end if;
          when 2 =>
            PRDATA <= x"0000_0001";
            pready <= '1';
            state := 0;
          when others =>
            assert false;
        end case;
      end if;
    end if;
  end process;
end RTL;
