#define CMD_ERROR        0
#define CMD_WRITE_WORD   1
#define CMD_READ_WORD    2
#define CMD_WRITE_BLOCK 16
#define CMD_SET_LEDS     3
#define CMD_GET_LEDS     4
#define CMD_I2C_TFR      5
#define CMD_I2C_STAT     6
#define CMD_I2C_BUF      7
#define CMD_I2C_MON      8
#define CMD_MON_BUF      9
#define CMD_STAT_BUF    10
#define CMD_FIP_PING    11
#define CMD_CPU_FLT     12
#define CMD_WRITE_ECC   13
#define CMD_WAIT        14

/* I2c commands  */
#define I2C_CMD_IDLE  0x00
#define I2C_CMD_ERR   0x10

#define I2C_CMD_START 0x01
#define I2C_CMD_WRITE 0x02
#define I2C_CMD_WRITE_STOP 0x03
#define I2C_CMD_READ  0x04
#define I2C_CMD_READ_STOP  0x05
#define I2C_CMD_READLEN  0x06
#define I2C_CMD_RUN   0x07

/* STAT registers  */
#define STAT_MONIMOD_RST 0   /* Number of monimod resets */
#define STAT_MIN_WD_CNT  1   /* Minimum watchdog counter */
#define STAT_RECOVERY    2   /* Number of recovery reset */
#define STAT_RESET       3   /* Number of reset */
#define STAT_LAST_RST    4   /* Last cpu reset */
#define STAT_CYCLE_CNT   5   /* Number of cycles executed */
#define STAT_FIP_CMD     6   /* Number of FIP commands (incl padding) */
#define STAT_FIP_PAD     7   /* Number of FIP padding command */
#define STAT_NBR         8
